2
0
mirror of https://gitlab.com/Nanolx/NanoDroid synced 2024-10-31 09:20:23 +00:00
NanoDroid/uninstaller/META-INF/com/google/android/update-binary
2020-01-31 18:17:50 +01:00

392 lines
9.8 KiB
Bash

#!/sbin/sh
OUTFD=$2
ZIP=$3
BACKUP_DIR="/data/media/0/nanodroid_backups"
VERSION=22.5.91.99999999
detect_bootmode () {
[ -z ${BOOTMODE} ] && BOOTMODE=false
${BOOTMODE} || ps | grep zygote | grep -qv grep && BOOTMODE=true
${BOOTMODE} || ps -A 2>/dev/null | grep zygote | grep -qv grep && BOOTMODE=true
${BOOTMODE} && error "NanoDroid Uninstaller can't be run from Magisk Manager!"
}
ui_print() {
echo -n -e "ui_print $1\n" >> /proc/self/fd/$OUTFD
echo -n -e "ui_print\n" >> /proc/self/fd/$OUTFD
}
grep_prop() {
REGEX="${1}"
shift
FILES="${@}"
[ -z "${@}" ] && FILES='/system/build.prop'
sed -n "s/^${REGEX}=//p" ${FILES} | \
head -n 1
}
grep_cmdline() {
local REGEX="s/^${1}=//p"
sed -E 's/ +/\n/g' /proc/cmdline | \
sed -n "${REGEX}" 2>/dev/null
}
is_mounted() {
if [ ! -z "$2" ]; then
cat /proc/mounts | grep $1 | grep $2, >/dev/null
else
cat /proc/mounts | grep $1 >/dev/null
fi
return $?
}
set_perm () {
chown ${2}:${3} ${1} || error "failed change owner for ${1}"
chmod ${4} ${1} || error "failed to change mode for ${1}"
if [ ! -z "${5}" ]; then
chcon ${5} ${1} 2>/dev/null
else chcon 'u:object_r:system_file:s0' ${1} 2>/dev/null
fi
}
set_perm_recursive() {
find ${1} -type d 2>/dev/null | while read dir; do
set_perm ${dir} ${2} ${3} ${4} ${6}
done
find ${1} -type f 2>/dev/null | while read file; do
set_perm ${file} ${2} ${3} ${5} ${6}
done
}
set_perm_data () {
if [ "${1}" = "-r" ]; then
echo " perm: data [recursive] {${2}}"
set_perm_recursive ${2} 0 0 0755 0644
else
echo " perm: data [single] {${1}}"
set_perm ${1} 0 0 0644
fi
}
setup_busybox () {
mkdir /dev/tmp
ABI=$(grep_prop ro.product.cpu.abi | cut -c-3)
ABI2=$(grep_prop ro.product.cpu.abi2 | cut -c-3)
ABILONG=$(grep_prop ro.product.cpu.abi)
ARCH=arm
[ "$ABI" = "x86" ] && ARCH=x86
[ "$ABI2" = "x86" ] && ARCH=x86
[ "$ABILONG" = "arm64-v8a" ] && ARCH=arm64
[ "$ABILONG" = "x86_64" ] && ARCH=x86_64
case ${ARCH} in
arm | arm64 )
unzip -oq "${ZIP}" busybox.arm -d "/dev/tmp"
BUSY=/dev/tmp/busybox.arm
;;
x86 | x86_64 )
unzip -oq "${ZIP}" busybox.x86 -d "/dev/tmp"
BUSY=/dev/tmp/busybox.x86
;;
esac
OLD_PATH=${PATH}
chmod 0755 ${BUSY}
mkdir -p /dev/tmp/busybox
ln -s ${BUSY} /dev/tmp/busybox/busybox
${BUSY} --install -s /dev/tmp/busybox/
export PATH="/dev/tmp/busybox:${PATH}"
}
error () {
ui_print " !!"
ui_print " !! ${@}"
ui_print " !!"
exit 1
}
mount_apex () {
APEX_FILE=""
APEX_DIR=""
APEX_LOOP=""
for apex in com.android.runtime com.android.runtime.release com.android.runtime.debug; do
if [ -f /system/apex/${apex}.apex ]; then
APEX_FILE=/system/apex/${apex}.apex
break
elif [ -d /system/apex/${apex} ]; then
APEX_DIR=/system/apex/${apex}
break
fi
done
if [ -n "${APEX_FILE}" ]; then
mkdir -p "${TMPDIR}/apex"
unzip -oq "${APEX_FILE}" -d "${TMPDIR}/apex"
mkdir -p /apex/com.android.runtime
mount -oloop,ro "${TMPDIR}/apex/apex_payload.img" /apex/com.android.runtime
APEX_LOOP=$(mount | awk '/com.android.runtime/{print $1}')
elif [ -n "${APEX_DIR}" ]; then
mkdir -p /apex
ln -sf "${APEX_DIR}" /apex/com.android.runtime
fi
}
# taken from Magisk, with minor modifications for NanoDroid
mount_partitions () {
DEVICE_AB=FALSE
VENDOR_COMPAT=FALSE
SYSTEM_AS_ROOT=FALSE
SLOT=$(grep_cmdline androidboot.slot_suffix)
echo " INFO: #1 [SLOT] ${SLOT}"
if [ -z ${SLOT} ]; then
SLOT=$(grep_cmdline androidboot.slot)
echo " INFO: #2 [SLOT] ${SLOT}"
if [ ! -z ${SLOT} ]; then
SLOT=_${SLOT}
echo " INFO: #3 [SLOT] ${SLOT}"
DEVICE_AB=TRUE
fi
fi
system_tmp=$(find /dev/block -type l -name system${SLOT} | head -n 1)
echo " INFO: #4 [system_tmp] ${system_tmp}"
SYSTEM_BLOCK=$(readlink -f ${system_tmp})
echo " INFO: #5 [SYSTEM_BLOCK] ${SYSTEM_BLOCK}"
is_mounted /data || mount /data || error "failed to mount /data!"
mount -o bind /dev/urandom /dev/random
! is_mounted /system && mount -o rw /system
! is_mounted /system && mount -o rw ${SYSTEM_BLOCK} /system
! is_mounted /system && error "failed to mount /system!"
if [ -f /system/init.rc ]; then
SYSTEM_AS_ROOT=true
[ -L /system_root ] && rm -f /system_root
mkdir /system_root 2>/dev/null
mount --move /system /system_root
mount -o bind /system_root/system /system
fi
vendor_tmp=$(find /dev/block -type l -name vendor${SLOT} | head -n 1)
echo " INFO: #6 [vendor_tmp] ${vendor_tmp}"
VENDOR_BLOCK=$(readlink -f ${vendor_tmp})
echo " INFO: #7 [VENDOR_BLOCK] ${VENDOR_BLOCK}"
! is_mounted /vendor && mount -o ro /vendor || mount -o ro ${VENDOR_BLOCK} /vendor
if [ -d /system/vendor ]; then
### XXX work-around required for some ROMs
VENDOR_COMPAT=TRUE
ln -sf /system/vendor /vendor >/dev/null
fi
echo " "
mount | awk '{print $1 " on " $3 " params: " $6}'
echo " "
echo " INFO: #8 [prop]"
ls -l /system/*.prop
export build_props=$(find /system /system_root /vendor -type f -name build.prop)
echo " INFO: #9 [build_props] ${build_props}"
[ -z "${build_props}" ] && error "failed to mount /system (unsupported A/B device?)"
mount_apex
}
# check for configuration files
config_locations="/data/media/0 /external_sd /sdcard1 /data $(dirname ${ZIP}))"
config_files=".nanodroid-setup .nanodroid-apps .nanodroid-overlay"
restore_apps () {
backup_path="${BACKUP_DIR}/$(grep_prop ro.build.flavor)_$(grep_prop ro.build.id)"
if [ -d ${backup_path}/app/ ]; then
for app in ${backup_path}/app/*; do
_app=$(basename ${app})
if [ -d /system/app/${_app} ]; then
ui_print " << removing backup: app:{_app}"
rm -rf "${app}"
else
ui_print " << restoring: app:${_app}"
mv "${app}" "/system/app/${_app}"
set_perm_data -r "/system/app/${_app}"
fi
done
rmdir ${backup_path}/app
fi
if [ -d ${backup_path}/priv-app/ ]; then
for app in ${backup_path}/priv-app/*; do
_app=$(basename ${app})
if [ -d /system/priv-app/${_app} ]; then
ui_print " << removing backup: priv-app:{_app}"
rm -rf "${app}"
else
ui_print " << restoring: priv-app:${_app}"
mv "${app}" "/system/priv-app/${_app}"
set_perm_data -r "/system/priv-app/${_app}"
fi
done
rmdir ${backup_path}/priv-app
fi
if [ -d ${backup_path}/reserve/ ]; then
for app in ${backup_path}/reserve/*; do
_app=$(basename ${app})
if [ -d /system/reserve/${_app} ]; then
ui_print " << removing backup: reserve:{_app}"
rm -rf "${app}"
else
ui_print " << restoring: reserve:${_app}"
mv "${app}" "/system/reserve/${_app}"
set_perm_data -r "/system/reserve/${_app}"
fi
done
rmdir ${backup_path}/reserve
fi
if [ -d ${backup_path}/product/app/ ]; then
for app in ${backup_path}/product/app/*; do
_app=$(basename ${app})
if [ -d /system/product/app/${_app} ]; then
ui_print " << removing backup: product/app:{_app}"
rm -rf "${app}"
else
ui_print " << restoring: product/app:${_app}"
mv "${app}" "/system/product/app/${_app}"
set_perm_data -r "/system/product/app/${_app}"
fi
done
rmdir ${backup_path}/product/app
fi
if [ -d ${backup_path}/product/priv-app/ ]; then
for app in ${backup_path}/product/priv-app/*; do
_app=$(basename ${app})
if [ -d /system/product/priv-app/${_app} ]; then
ui_print " << removing backup: product/priv-app:{_app}"
rm -rf "${app}"
else
ui_print " << restoring: product/priv-app:${_app}"
mv "${app}" "/system/product/priv-app/${_app}"
set_perm_data -r "/system/product/priv-app/${_app}"
fi
done
rmdir ${backup_path}/product/priv-app
fi
}
system_mode_uninstall () {
ui_print " << uninstalling: NanoDroid (System)"
ui_print " << using: ${1}"
system_list=${1}
if test -h /system/fonts/Roboto-Regular.ttf; then
CUSTOM_FONT="$(basename $(readlink /system/fonts/Roboto-Regular.ttf) .ttf)"
ui_print " << Detected NanoDroid-Font (${CUSTOM_FONT})"
ui_print " < Restoring original Font"
${NANODROID_BINDIR}/nanodroid-font -r
fi
restore_apps
xargs rm < ${system_list} || error "failed to remove files"
# remove empty directories
# (find -empty not available on Android)
for dir in app priv-app; do
find /system/${dir} -type d | xargs rmdir -p
done
rm -f "${system_list}"
}
patcher_uninstall () {
if [ -f /data/adb/NanoDroid_Patched ]; then
services_name="services.jar_$(grep_prop ro.build.flavor)_$(grep_prop ro.build.id)"
if [ -f ${BACKUP_DIR}/${services_name} ]; then
ui_print " << restoring: unpatched services.jar"
mv "${BACKUP_DIR}/${services_name}" /system/framework/services.jar
set_perm_data /system/framework/services.jar
else ui_print " << can't restore unpatched services.jar"
fi
fi
[ -d /data/adb/nanodroid_patcher ] && rm -rf /data/adb/nanodroid_patcher
[ -f /system/addon.d/70-nanodroidpatcher.sh ] && rm -f ${addonsh}
[ -f /data/adb/NanoDroid_Patched ] && rm -f ${pfile}
}
ui_print " "
ui_print "**********************"
ui_print " NanoDroid "
ui_print " Uninstaller "
ui_print " ${VERSION} "
ui_print "**********************"
ui_print " "
detect_bootmode
mount_partitions
ui_print " << Removing installation logs (if any)"
# old format
rm -f /data/adb/NanoDroid_log*
rm -f /data/adb/NanoDroid_twrp*
# new format
rm -rf /data/media/0/nanodroid_logs
# System Mode uninstallation
[ -f /data/adb/NanoDroid_FileList ] && system_mode_uninstall /data/adb/NanoDroid_FileList
patcher_uninstall
for module in NanoDroid NanoDroid_microG NanoDroid_FDroid \
NanoDroid_BromiteWebView NanoDroid_OsmAnd NanoDroid_Google; do
if [ -d /data/adb/modules/${module} ]; then
ui_print " << uninstalling: ${module}"
rm -rf /data/adb/modules/${module}
fi
done
rm -f /data/adb/.nanodroid_runtimeclean
ui_print " >> clean up"
umount -l /system_root 2>/dev/null
umount -l /system 2>/dev/null
umount -l /vendor 2>/dev/null
umount -l /dev/random 2>/dev/null
umount -l /apex/com.android.runtime 2>/dev/null
losetup -d ${APEX_LOOP} 2>/dev/null
ui_print " "
ui_print " > Done!"
ui_print " "
ui_print "Thanks for giving NanoDroid a try"
ui_print " "
exit 0